﻿using SAIB_Web_Api.BusinessManager;
using SAIB_Web_Api.Helper;
using SAIB_Web_Api.Models.Request;
using SAIB_Web_Api.Models.Response;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Net.Http;
using System.Web.Http;
using System.Security.Authentication;

namespace SAIB_Web_Api.Controllers
{
    [MyAuthorizationFilter]
    public class PromotionController : ApiController
    {
        PromotionMaster promotion = new PromotionMaster();

        [Route(RouteConfig.PromotionGet)]
        [HttpGet]
        public List<PromotionDetailsResponse> GetPromotionMasterDetails(int PromotionID)
        {

            try
            {
                return promotion.GetPromotionMasterDetails(PromotionID);
            }
            catch (AuthenticationException)
            {
                throw HttpErrorResponseHelper.GenerateUnauthorised(Request);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }

        [Route(RouteConfig.PromotionAdd)]
        [HttpPost]
        public bool PromotionAddNewRecord(PromotionDetailsRequest promotionDetailsRequest)
        {
            try
            {
                return promotion.PromotionAddNewRecord(promotionDetailsRequest);
            }

            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }

        [Route(RouteConfig.PromotionChecker)]
        [HttpPatch]
        public List<PromotionCheckerResponse> PromotionCheckerApprove(CheckerRequest checkerRequest)
        {
            try
            {
                return promotion.PromotionCheckerApprove(checkerRequest.PromotionID, checkerRequest.Status, checkerRequest.UserID);
            }
            catch (Exception ex)
            {
                throw HttpErrorResponseHelper.GenerateInternalServerError(Request, ex.Message);
            }
        }
    }
}

